//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "LogUnit.h"
#include "ScopedLock.h"
#include "Mutex.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmLog *frmLog;
//---------------------------------------------------------------------------
__fastcall TfrmLog::TfrmLog(TComponent* Owner)
	: TForm(Owner)
{
	callbackClose = NULL;
}
//---------------------------------------------------------------------------

void TfrmLog::OnLog(char *buf)
{
	ScopedLock<Mutex> lock(mutex);
	que.push_back(buf);
	if (que.size() > 250)
		que.pop_front();
}
void __fastcall TfrmLog::tmrUpdateTimer(TObject *Sender)
{
	if (!Visible)
		return;
	ScopedLock<Mutex> lock(mutex);
	ListView->Items->Count = que.size();
	ListView->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TfrmLog::ListViewData(TObject *Sender, TListItem *Item)
{
	ScopedLock<Mutex> lock(mutex);
	Item->Caption = que[Item->Index].c_str();
}
//---------------------------------------------------------------------------

void __fastcall TfrmLog::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (callbackClose)
		callbackClose();	
}
//---------------------------------------------------------------------------

