#ifndef MiniscopeDeviceCapabilitiesH
#define MiniscopeDeviceCapabilitiesH

enum E_TRIGGER_TYPE
{
    TRIGGER_MANUAL = 0,
    TRIGGER_SLOPE_UP,
    TRIGGER_SLOPE_DOWN
};

struct S_SCOPE_CAPABILITIES
{
    unsigned int iChannelCount;
    unsigned int iBitsPerSample;
    unsigned int iSensitivityLevelsCount;
    float *fSensitivityLevels;          ///< ptr to array of sensitivity per LSB values (array size defined by iSensitivityLevelsCount)
    unsigned int iSamplingPeriodCount;
    float *fSamplingPeriod;      		///< ptr to sampling period array [s]
    unsigned int iTriggerTypeCount;
    unsigned int *iTriggerTypes;
    unsigned int iCouplingTypeCount;
    unsigned int *iCouplingType;
    unsigned int iBufferSizeCount;
    unsigned int *iBufferSizes;
    unsigned int iOffset;               ///< is offset setting available?
};

#endif // MiniscopeDeviceCapabilitiesH
